Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.App/Runner.cs	(revision 18045)
@@ -12,25 +12,19 @@
   internal static class Runner {
     internal static void Run(string template, string config, string outputFile) {
-      try {
-        InstantiatorResult instantiatorResult = JsonTemplateInstantiator.Instantiate(template, config);
-        IOptimizer optimizer = instantiatorResult.Optimizer;
-        IEnumerable<IResultJsonItem> configuredResultItem = instantiatorResult.ConfiguredResultItems;
+      InstantiatorResult instantiatorResult = JsonTemplateInstantiator.Instantiate(template, config);
+      IOptimizer optimizer = instantiatorResult.Optimizer;
+      IEnumerable<IResultJsonItem> configuredResultItem = instantiatorResult.ConfiguredResultItems;
 
-        optimizer.Runs.Clear();
-        if (optimizer is EngineAlgorithm e)
-          e.Engine = new ParallelEngine.ParallelEngine();
+      optimizer.Runs.Clear();
+      if (optimizer is EngineAlgorithm e)
+        e.Engine = new ParallelEngine.ParallelEngine();
 
-        Task task = optimizer.StartAsync();
-        while (!task.IsCompleted) {
-          WriteResultsToFile(outputFile, optimizer, configuredResultItem);
-          Thread.Sleep(100);
-        }
+      Task task = optimizer.StartAsync();
+      while (!task.IsCompleted) {
+        WriteResultsToFile(outputFile, optimizer, configuredResultItem);
+        Thread.Sleep(100);
+      }
 
-        WriteResultsToFile(outputFile, optimizer, configuredResultItem);
-      } catch (Exception e) {
-        Console.Error.WriteLine($"{e.Message} \n\n\n\n {e.StackTrace}");
-        File.WriteAllText(outputFile, e.Message + "\n\n\n\n" + e.StackTrace);
-        Environment.Exit(-1);
-      }
+      WriteResultsToFile(outputFile, optimizer, configuredResultItem);
     }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ParameterizedItemConverter.cs	(revision 18045)
@@ -11,5 +11,5 @@
 
     public override void Inject(IItem item, IJsonItem data, IJsonItemConverter root) {
-      IParameterizedItem pItem = item as IParameterizedItem;
+      var pItem = item as IParameterizedItem;
 
       if(data.Children != null) {
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/RegressionProblemDataConverter.cs	(revision 18045)
@@ -43,9 +43,7 @@
       StringArrayJsonItem allowedInputVariables = null;
 
-
       // search first for the items (cache them, because the 
       // order is important for injection)
       foreach (var child in data.Children) {
-
         if (child.Path.EndsWith(Dataset))
           dataset = child as DoubleMatrixJsonItem;
@@ -58,5 +56,4 @@
         else if (child.Path.EndsWith(AllowedInputVariables))
           allowedInputVariables = child as StringArrayJsonItem;
-
       }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueLookupParameterConverter.cs	(revision 18045)
@@ -20,5 +20,4 @@
     public override IJsonItem Extract(IItem value, IJsonItemConverter root) {
       IValueLookupParameter param = value as IValueLookupParameter;
-
       IValueLookupJsonItem item = new ValueLookupJsonItem();
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Converters/ValueParameterConverter.cs	(revision 18045)
@@ -13,9 +13,7 @@
       IParameter parameter = value as IParameter;
 
-      if (!(data is EmptyJsonItem)) {
-        if (parameter.ActualValue == null)
-          parameter.ActualValue = Instantiate(parameter.DataType);
-        root.Inject(parameter.ActualValue, data, root);
-      }
+      if (parameter.ActualValue == null)
+        parameter.ActualValue = Instantiate(parameter.DataType);
+      root.Inject(parameter.ActualValue, data, root);
     }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.PluginInfrastructure/3.3/Main.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.PluginInfrastructure/3.3/Main.cs	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.PluginInfrastructure/3.3/Main.cs	(revision 18045)
@@ -56,23 +56,24 @@
 
     public static void HeadlessRun(string[] args) {
-      string pluginPath = Path.GetFullPath(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location));
-      var pluginManager = new PluginManager(pluginPath);
-      pluginManager.DiscoverAndCheckPlugins();
+      try {
+        string pluginPath = Path.GetFullPath(Path.GetDirectoryName(Assembly.GetEntryAssembly().Location));
+        var pluginManager = new PluginManager(pluginPath);
+        pluginManager.DiscoverAndCheckPlugins();
 
-      var arguments = CommandLineArgumentHandling.GetArguments(args);
-      foreach (var argument in arguments) {
-        if (argument is StartArgument) {
-          var arg = (StartArgument)argument;
-          var appDesc = (from desc in pluginManager.Applications
-                         where desc.Name.Equals(arg.Value)
-                         select desc).SingleOrDefault();
-          if (appDesc != null) {
-            try {
+        var arguments = CommandLineArgumentHandling.GetArguments(args);
+        foreach (var argument in arguments) {
+          if (argument is StartArgument) {
+            var arg = (StartArgument)argument;
+            var appDesc = (from desc in pluginManager.Applications
+                           where desc.Name.Equals(arg.Value)
+                           select desc).SingleOrDefault();
+            if (appDesc != null) {
               pluginManager.Run(appDesc, arguments);
-            } catch (Exception e) {
-              Console.WriteLine(e.Message);
             }
           }
         }
+      } catch (Exception e) {
+        Console.Error.WriteLine($"{e.Message} \n\n {e.StackTrace}");
+        Environment.Exit(-1);
       }
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab/3.3/HeuristicLab-3.3.csproj
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 18044)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab/3.3/HeuristicLab-3.3.csproj	(revision 18045)
@@ -23,4 +23,7 @@
     <OldToolsVersion>3.5</OldToolsVersion>
     <UpgradeBackupLocation />
+    <IsWebBootstrapper>false</IsWebBootstrapper>
+    <TargetFrameworkProfile>
+    </TargetFrameworkProfile>
     <PublishUrl>publish\</PublishUrl>
     <Install>true</Install>
@@ -35,9 +38,6 @@
     <ApplicationRevision>0</ApplicationRevision>
     <ApplicationVersion>1.0.0.%2a</ApplicationVersion>
-    <IsWebBootstrapper>false</IsWebBootstrapper>
     <UseApplicationTrust>false</UseApplicationTrust>
     <BootstrapperEnabled>true</BootstrapperEnabled>
-    <TargetFrameworkProfile>
-    </TargetFrameworkProfile>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">