Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 18046)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/HeuristicLab.JsonInterface.OptimizerIntegration.csproj	(revision 18047)
@@ -155,4 +155,10 @@
     <Compile Include="Plugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Views\ResultCollectionPostProcessorControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Views\ResultCollectionPostProcessorControl.Designer.cs">
+      <DependentUpon>ResultCollectionPostProcessorControl.cs</DependentUpon>
+    </Compile>
     <Compile Include="Views\ResultJsonItemControl.cs">
       <SubType>UserControl</SubType>
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 18046)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.Designer.cs	(revision 18047)
@@ -176,9 +176,9 @@
       this.splitContainer2.TabIndex = 9;
       // postProcessorListView
-      this.postProcessorListView = new Core.Views.CheckedItemListView<IResultCollectionPostProcessor>();
-      this.postProcessorListView.Content = new CheckedItemList<IResultCollectionPostProcessor>();
-      this.postProcessorListView.Content.Add(new SymRegPythonPostProcessor());
-      this.postProcessorListView.Location = new System.Drawing.Point(0, 6);
-      this.postProcessorListView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.postProcessorListControl = new ResultCollectionPostProcessorControl();
+      this.postProcessorListControl.Content = new CheckedItemList<IResultCollectionPostProcessor>();
+      this.postProcessorListControl.Content.Add(new SymRegPythonPostProcessor());
+      this.postProcessorListControl.Location = new System.Drawing.Point(0, 6);
+      this.postProcessorListControl.Dock = System.Windows.Forms.DockStyle.Fill;
       // 
       // tabControl1
@@ -220,5 +220,5 @@
       // tabPage3
       // 
-      this.tabPage3.Controls.Add(this.postProcessorListView);
+      this.tabPage3.Controls.Add(this.postProcessorListControl);
       this.tabPage3.Location = new System.Drawing.Point(4, 22);
       this.tabPage3.Name = "tabPage3";
@@ -310,5 +310,5 @@
     private System.Windows.Forms.Panel panelResultDetails;
     private System.Windows.Forms.TabPage tabPage3;
-    private Core.Views.CheckedItemListView<IResultCollectionPostProcessor> postProcessorListView;
+    private ResultCollectionPostProcessorControl postProcessorListControl;
   }
 }
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 18046)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ExportJsonDialog.cs	(revision 18047)
@@ -61,5 +61,5 @@
     public ExportJsonDialog() {
       InitializeComponent();
-      this.PostProcessors = this.postProcessorListView.Content;
+      this.PostProcessors = this.postProcessorListControl.Content;
       this.Icon = HeuristicLab.Common.Resources.HeuristicLab.Icon;
       InitCache();
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.Designer.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.Designer.cs	(revision 18047)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.Designer.cs	(revision 18047)
@@ -0,0 +1,33 @@
+﻿
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  partial class ResultCollectionPostProcessorControl {
+    /// <summary> 
+    /// Erforderliche Designervariable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Verwendete Ressourcen bereinigen.
+    /// </summary>
+    /// <param name="disposing">True, wenn verwaltete Ressourcen gelöscht werden sollen; andernfalls False.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Vom Komponenten-Designer generierter Code
+
+    /// <summary> 
+    /// Erforderliche Methode für die Designerunterstützung. 
+    /// Der Inhalt der Methode darf nicht mit dem Code-Editor geändert werden.
+    /// </summary>
+    private void InitializeComponent() {
+      components = new System.ComponentModel.Container();
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+    }
+
+    #endregion
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.cs	(revision 18047)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface.OptimizerIntegration/Views/ResultCollectionPostProcessorControl.cs	(revision 18047)
@@ -0,0 +1,64 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Data;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+using System.Windows.Forms;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.JsonInterface.OptimizerIntegration {
+  public partial class ResultCollectionPostProcessorControl : Core.Views.CheckedItemListView<IResultCollectionPostProcessor> {
+    public ResultCollectionPostProcessorControl() {
+      InitializeComponent();
+    }
+
+    #region Content Events
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content != null) {
+        SetNumberOfCheckItems();
+      }
+    }
+
+    protected override void Content_CheckedItemsChanged(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_CheckedItemsChanged(sender, e);
+      if (InvokeRequired)
+        Invoke(new CollectionItemsChangedEventHandler<IndexedItem<IResultCollectionPostProcessor>>(Content_CheckedItemsChanged), sender, e);
+      else {
+        SetNumberOfCheckItems();
+      }
+    }
+    protected override void Content_CollectionReset(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_CollectionReset(sender, e);
+      SetNumberOfCheckItems();
+    }
+    protected override void Content_ItemsAdded(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_ItemsAdded(sender, e);
+      SetNumberOfCheckItems();
+    }
+    protected override void Content_ItemsMoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_ItemsMoved(sender, e);
+      SetNumberOfCheckItems();
+    }
+    protected override void Content_ItemsRemoved(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_ItemsRemoved(sender, e);
+      SetNumberOfCheckItems();
+    }
+    protected override void Content_ItemsReplaced(object sender, CollectionItemsChangedEventArgs<IndexedItem<IResultCollectionPostProcessor>> e) {
+      base.Content_ItemsReplaced(sender, e);
+      SetNumberOfCheckItems();
+    }
+    #endregion
+
+    private void SetNumberOfCheckItems() { // TODO: eigene override für "Post Processors" -> Item Naming
+      if (InvokeRequired) {
+        Invoke((Action)SetNumberOfCheckItems);
+      } else {
+        this.itemsGroupBox.Text = String.Format("Post Processors (Checked: {0}/{1})", Content.CheckedItems.Count(), Content.Count);
+      }
+    }
+  }
+}
Index: branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultCollectionPostProcessors/SymRegPythonPostProcessor.cs
===================================================================
--- branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultCollectionPostProcessors/SymRegPythonPostProcessor.cs	(revision 18046)
+++ branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/ResultCollectionPostProcessors/SymRegPythonPostProcessor.cs	(revision 18047)
@@ -32,5 +32,4 @@
     }
 
-
     public override IDeepCloneable Clone(Cloner cloner) {
       return new SymRegPythonPostProcessor(this, cloner);