Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 18049)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/HeuristicLab.Problems.DataAnalysis.Symbolic.Views-3.4.csproj	(revision 18051)
@@ -122,4 +122,10 @@
       <DependentUpon>InteractiveSymbolicExpressionTreeChart.cs</DependentUpon>
     </Compile>
+    <Compile Include="RunCollectionPartialDependencePlotView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="RunCollectionPartialDependencePlotView.Designer.cs">
+      <DependentUpon>RunCollectionPartialDependencePlotView.cs</DependentUpon>
+    </Compile>
     <Compile Include="SymbolicDataAnalysisModelMathView.cs">
       <SubType>UserControl</SubType>
@@ -276,4 +282,8 @@
       <Name>HeuristicLab.Problems.DataAnalysis.Symbolic-3.4</Name>
       <Private>False</Private>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis.Views\3.4\HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj">
+      <Project>{3E9E8944-44FF-40BB-A622-3A4A7DD0F198}</Project>
+      <Name>HeuristicLab.Problems.DataAnalysis.Views-3.4</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Problems.DataAnalysis\3.4\HeuristicLab.Problems.DataAnalysis-3.4.csproj">
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.Designer.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.Designer.cs	(revision 18051)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.Designer.cs	(revision 18051)
@@ -0,0 +1,52 @@
+﻿namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  partial class RunCollectionPartialDependencePlotView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+            this.mainPanel = new System.Windows.Forms.Panel();
+            this.SuspendLayout();
+            // 
+            // mainPanel
+            // 
+            this.mainPanel.Dock = System.Windows.Forms.DockStyle.Fill;
+            this.mainPanel.Location = new System.Drawing.Point(0, 0);
+            this.mainPanel.Name = "mainPanel";
+            this.mainPanel.Size = new System.Drawing.Size(490, 246);
+            this.mainPanel.TabIndex = 0;
+            // 
+            // RunCollectionPartialDependencePlotView
+            // 
+            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+            this.Controls.Add(this.mainPanel);
+            this.Name = "RunCollectionPartialDependencePlotView";
+            this.Size = new System.Drawing.Size(490, 246);
+            this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Panel mainPanel;
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.cs	(revision 18051)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/RunCollectionPartialDependencePlotView.cs	(revision 18051)
@@ -0,0 +1,43 @@
+﻿using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Optimization;
+using HeuristicLab.Problems.DataAnalysis.Views;
+
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic.Views {
+  [Content(typeof(RunCollection), false)]
+  [View("RunCollection Partial Dependence Plots")]
+  public partial class RunCollectionPartialDependencePlotView : AsynchronousContentView {
+    public new RunCollection Content {
+      get => (RunCollection)base.Content;
+      set => base.Content = value;
+    }
+
+    public RunCollectionPartialDependencePlotView() {
+      InitializeComponent();
+    }
+
+    private static async void AddSolution(RegressionSolutionPartialDependencePlotView plot, IEnumerable<IRegressionSolution> solutions) {
+      foreach(var sol in solutions) {
+        await plot.AddSolution(sol);
+      }
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+
+      if (Content == null) return;
+
+      var solutions = Content.Select(run => (IRegressionSolution)run.Results["Best training solution"]).ToList();
+      var plot = new RegressionSolutionPartialDependencePlotView {
+        Content = solutions[0],
+        Dock = DockStyle.Fill
+      };
+
+      mainPanel.Controls.Add(plot);
+      AddSolution(plot, solutions);
+    }
+  }
+}
Index: trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Controls/PartialDependencePlot.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Controls/PartialDependencePlot.cs	(revision 18049)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Controls/PartialDependencePlot.cs	(revision 18051)
@@ -453,15 +453,17 @@
     }
 
-    private async Task<DoubleLimit> UpdateAllSeriesDataAsync(CancellationToken cancellationToken) {
+    private Task<DoubleLimit> UpdateAllSeriesDataAsync(CancellationToken cancellationToken) {
       var updateTasks = solutions.Select(solution => UpdateSeriesDataAsync(solution, cancellationToken));
 
-      double min = double.MaxValue, max = double.MinValue;
-      foreach (var update in updateTasks) {
-        var limit = await update;
-        if (limit.Lower < min) min = limit.Lower;
-        if (limit.Upper > max) max = limit.Upper;
-      }
-
-      return new DoubleLimit(min, max);
+      return Task.Run(() => {
+        double min = double.MaxValue, max = double.MinValue;
+        foreach (var update in updateTasks) {
+          var limit = update.Result;
+          if (limit.Lower < min) min = limit.Lower;
+          if (limit.Upper > max) max = limit.Upper;
+        }
+
+        return new DoubleLimit(min, max);
+      }, cancellationToken);
     }
 
Index: trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionPartialDependencePlotView.cs
===================================================================
--- trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionPartialDependencePlotView.cs	(revision 18049)
+++ trunk/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionPartialDependencePlotView.cs	(revision 18051)
@@ -237,4 +237,10 @@
 
       RecalculateAndRelayoutCharts();
+    }
+
+    public async Task AddSolution(IRegressionSolution solution) {
+      foreach (var chart in partialDependencePlots.Values) {
+        await chart.AddSolutionAsync(solution);
+      }
     }
 